/**
 * @author Andy Li andy@onthewings.net
 */
 
import __AS3__.vec.Vector;

import flash.events.Event;
import flash.utils.ByteArray;
import flash.utils.getTimer;

import mx.controls.Button;

public var numOfConcate:Number = 10000;
public var concateString:String = "someLongLongLongLongLongLongLongLongLongString";

public var t:Number;
public var result:String;

public function showResultIfNeeded():void {
	if (showResultString.selected) resultArea.text = result;
}

public function testStringPlusEqual(evt:Event):void {
	t = getTimer();
	var str:String = "";
    for (var i:Number = 0 ; i< numOfConcate; ++i) {
    	str += concateString;
    }
    result = str;
    showResultIfNeeded();
    (evt.target as Button).label = (getTimer()-t).toString() + 'ms';
}

public function testStringConcate(evt:Event):void {
	t = getTimer();
	var str:String = "";
    for (var i:Number = 0 ; i< numOfConcate; ++i) {
    	str = str.concat(concateString);
    }
    result = str;
    showResultIfNeeded();
    (evt.target as Button).label = (getTimer()-t).toString() + 'ms';
}

public function testArrayJoin(evt:Event):void {
	t = getTimer();
	var str:Array = [];
    for (var i:Number = 0 ; i< numOfConcate; ++i) {
    	str.push(concateString);
    }
    result = str.join("");
    showResultIfNeeded();
    (evt.target as Button).label = (getTimer()-t).toString() + 'ms';
}

public function testVectorJoin(evt:Event):void {
	t = getTimer();
	var str:Vector.<String> = new Vector.<String>();
    for (var i:Number = 0 ; i< numOfConcate; ++i) {
    	str.push(concateString);
    }
    result = str.join("");
   	showResultIfNeeded();
    (evt.target as Button).label = (getTimer()-t).toString() + 'ms';
}

public function testByteArrayUTFBytes(evt:Event):void {
	t = getTimer();
	var str:ByteArray = new ByteArray();
    for (var i:Number = 0 ; i< numOfConcate; ++i) {
    	str.writeUTFBytes(concateString);
    }
	str.position = 0;
	result = str.readUTFBytes(str.length);
	showResultIfNeeded();
    (evt.target as Button).label = (getTimer()-t).toString() + 'ms';
    str.clear();
}

public function testByteArrayMultiByteASCII(evt:Event):void {
	t = getTimer();
	var str:ByteArray = new ByteArray();
    for (var i:Number = 0 ; i< numOfConcate; ++i) {
    	str.writeMultiByte(concateString,"us-ascii");
    }
	str.position = 0;
	result = str.readMultiByte(str.length,"us-ascii");
	showResultIfNeeded();
    (evt.target as Button).label = (getTimer()-t).toString() + 'ms';
    str.clear();
}